// MainDlg.cpp : implementation of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "MainDlg.h"

INT WINAPI GetSize(CString csFilePath)
{
	DWORD dwFileSize, dwHiSize;
	HANDLE hFile = CreateFile(csFilePath.GetBuffer(MAX_PATH), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	csFilePath.ReleaseBuffer();

	if (INVALID_HANDLE_VALUE == hFile)	return 0;

	dwFileSize	=	GetFileSize(hFile, &dwHiSize);
	CloseHandle(hFile);

	 //  4G µļ
	if (dwHiSize)
	{
		dwFileSize	=	0;
		MessageBox(NULL, NULL, _T(" 4G µļ"), MB_OK|MB_ICONERROR);	
	}

	return dwFileSize;
}

LRESULT CMainDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	// center the dialog on the screen
	CenterWindow();

	// set icons
	HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
		IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
	SetIcon(hIcon, TRUE);
	HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
		IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
	SetIcon(hIconSmall, FALSE);

	m_nFileSize = m_nFileSize2 = m_nOffset = m_nAddSize = 0;
	DragAcceptFiles(TRUE);

	return TRUE;
}

LRESULT CMainDlg::OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CSimpleDialog<IDD_ABOUTBOX, FALSE> dlg;
	dlg.DoModal();
	return 0;
}

LRESULT CMainDlg::OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	// TODO: Add validation code 
	EndDialog(wID);
	return 0;
}

LRESULT CMainDlg::OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	EndDialog(wID);
	return 0;
}

LRESULT CMainDlg::OnBnClickedBtnSelect(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize	=	sizeof(ofn);
	ofn.Flags	=	OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;
	ofn.lpstrTitle	=	_T("ѡһļ");
	ofn.nMaxFile	=	MAX_PATH;
	ofn.lpstrFile	=	m_csFile.GetBuffer(MAX_PATH);
	ofn.lpstrFilter	=	_T("ִļ(*.exe)\0*.exe\0̬ӿ(*.dll)\0*.dll\0ļ(*.*)\0*.*\0\0");

	if (!GetOpenFileName(&ofn))	
	{
		m_csFile.ReleaseBuffer();
		return 0;
	}

	m_csFile.ReleaseBuffer();
	m_nFileSize	=	GetSize(m_csFile);
	DoDataExchange(FALSE);

	return 0;
}

LRESULT CMainDlg::OnBnClickedBtnSelecttoadd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize	=	sizeof(ofn);
	ofn.Flags	=	OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;
	ofn.lpstrTitle	=	_T("ѡһļ");
	ofn.nMaxFile	=	MAX_PATH;
	ofn.lpstrFile	=	m_csFileToAdd.GetBuffer(MAX_PATH);
	ofn.lpstrFilter	=	_T("ִļ(*.exe)\0*.exe\0̬ӿ(*.dll)\0*.dll\0ļ(*.*)\0*.*\0\0");

	if (!GetOpenFileName(&ofn))	
	{
		m_csFileToAdd.ReleaseBuffer();
		return 0;
	}

	m_csFileToAdd.ReleaseBuffer();
	m_nFileSize2	=	GetSize(m_csFileToAdd);
	DoDataExchange(FALSE);

	return 0;
}

BOOL CMainDlg::IsAllOK()
{
	DoDataExchange(TRUE);
	if (m_nFileSize <= 0 || m_nFileSize2 <= 0 || m_nAddSize <=0 || m_nAddSize <= 0)	return FALSE; // һСڵ 0
	if ((m_nFileSize2 >= m_nFileSize)&&(m_nOffset!=m_nFileSize)) return FALSE; // ҪǶļļ,ʱƫƴСΪļСʾҪӵļĩβ
	if ((m_nFileSize - m_nOffset < m_nAddSize)&&(m_nOffset!=m_nFileSize)) return FALSE; // ļռ䲻,ʱƫƴСΪļСʾҪӵļĩβ
	if (m_nAddSize > m_nFileSize2) return FALSE; // ǶСǶļ

	return TRUE;
}

LRESULT CMainDlg::OnBnClickedBtnStart(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	HANDLE hFile, hFileToAdd, hMap;
	LPVOID lpMemory;
	DWORD dwWrited;
	CString csError;

	DoDataExchange(TRUE);

	if (!IsAllOK())	
	{
		MessageBox(_T("ȷټһΣ"), _T(""), MB_OK|MB_ICONERROR);
		return 0;
	}

	hFile = CreateFile(m_csFile, GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if (INVALID_HANDLE_VALUE == hFile) 
	{
		wsprintf(csError.GetBuffer(MAX_PATH), _T("޷ļ \n%s\nļʹУرصļһΡ"), m_csFile.GetBuffer(MAX_PATH));
		csError.ReleaseBuffer();
		m_csFile.ReleaseBuffer();
		MessageBox(csError);
		return 0;
	}

	hFileToAdd = CreateFile(m_csFileToAdd, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	
	if (INVALID_HANDLE_VALUE == hFileToAdd) 
	{
		wsprintf(csError.GetBuffer(MAX_PATH), _T("޷ļ \n%s\nļʹУرصļһΡ"), m_csFileToAdd.GetBuffer(MAX_PATH));
		csError.ReleaseBuffer();
		m_csFileToAdd.ReleaseBuffer();
		MessageBox(csError);
		return 0;
	}

	CopyFile(m_csFile, m_csFile+_T(".bak"), FALSE);

	SetFilePointer(hFile, m_nOffset, NULL, FILE_BEGIN);
	hMap = CreateFileMapping(hFileToAdd, NULL, PAGE_READONLY, 0, 0, NULL);
	CloseHandle(hFileToAdd);
	lpMemory = MapViewOfFile(hMap, FILE_MAP_READ, 0, 0, m_nAddSize);

	if (NULL != lpMemory)
	{
		WriteFile(hFile, lpMemory, m_nAddSize, &dwWrited, NULL);
		UnmapViewOfFile(lpMemory);
		CloseHandle(hMap);
	}

	CloseHandle(hFile);

	wsprintf(csError.GetBuffer(MAX_PATH), _T("дɹ\nƫ:%d (ֽ)\nǶС:%d (ֽ)"), m_nOffset, m_nAddSize);
	csError.ReleaseBuffer();
	MessageBox(csError);

	return 0;
}


void CMainDlg::OnDropFiles(HDROP hDropInfo)
{
	POINT	stPoint;
	RECT	stFileRect, stFileToAddRect;
	CString	csFile;
	::GetWindowRect(GetDlgItem(IDC_EDIT_FILE), &stFileRect);
	::GetWindowRect(GetDlgItem(IDC_EDIT_FILETOADD), &stFileToAddRect);
	ScreenToClient(&stFileRect);
	ScreenToClient(&stFileToAddRect);
	DragQueryPoint(hDropInfo, &stPoint);
	
	if (PtInRect(&stFileRect, stPoint))
	{
		DragQueryFile(hDropInfo, 0, csFile.GetBuffer(MAX_PATH), MAX_PATH);
		csFile.ReleaseBuffer();

		if (!(FILE_ATTRIBUTE_DIRECTORY & GetFileAttributes(csFile)))	
		{	
			m_csFile	=	csFile;
			m_nFileSize	=	GetSize(m_csFile);
		}

	}else if (PtInRect(&stFileToAddRect, stPoint))
	{
		DragQueryFile(hDropInfo, 0, csFile.GetBuffer(MAX_PATH), MAX_PATH);
		csFile.ReleaseBuffer();

		if (!(FILE_ATTRIBUTE_DIRECTORY & GetFileAttributes(csFile)))	
		{	
			m_csFileToAdd	=	csFile;
			m_nFileSize2	=	GetSize(m_csFileToAdd);
		}
	}
	
	DragFinish(hDropInfo);
	DoDataExchange(FALSE);
}
